#include <string.h>
#include <fstream.h>
#include <stdlib.h>
#include <new.h>
#include <stdlib.h>


const int luninfo= 20;
const int luninfo4trash = 200;
const int lunverb= 10000;
const char* filename ="trans.ia";        //File used during the reading
const char* commandsfile ="commands.ia"; //File 4 commands
const char* exefile="exe"; //File used to execute a command
const char* speedanswerfile="spdans.ia"; //File 4 speed answer
const char* memoryfile ="memory.ia";     //File of memory
const char* verbtablefile ="verbs.ia";   //File 4 verb table
char username [luninfo]; //User name
char userobject [luninfo];  //User's

struct elem 
{
char info [luninfo];
elem* more;
};

struct spd
{
elem* ask;
elem* answer;
spd * next;
};


struct command
{
elem* ask;
elem* execute;
command * next;
};





elem* l1;
elem* l2;
elem* l3;
elem* buffer;
elem* ll1;
elem* ll2;
elem* ll3;
elem* verbtable;
int types [lunverb];
int times [lunverb];
spd* speedtable;

command* commandstable;

#include "myheader.cpp"
#include "struct.h"

object* memory;

#include "reason.cpp"
#include "execute.cpp"
#include "commands.cpp"
#include "spdanswr.cpp"
#include "struct.cpp"
#include "affermat.cpp"
#include "interrog.cpp"
#include "disk.cpp"
#include "start.cpp"
#include "end.cpp"
#include "read.cpp"
#include "talking.cpp"






int main ()
{
set_new_handler(endofmemory);     
cout <<"                *** PAI version 2.10 by Claudio Scordino (2001) ***" << endl;
init();
talking();
}
