object* buildobject (elem* a)
{
object* p;
p=new object;
p->it=a;
p->toverb=NULL;
p->next=NULL;
return p;
}

verb* buildverb (elem* a,int ty, int ti)
{
verb* p;
p=new verb;
p->it=a;
p->toattrib=NULL;
p->next=NULL;
p->type=ty;
p->time=ti;
return p;
}



attrib* buildattrib (elem* a,int goo)
{
attrib* p;
p=new attrib;
p->it=a;
p->next=NULL;
p->good=goo;
p->number=0;
p->why_number=0;
p->why=NULL;
p->so_number=0;
p->so=NULL;
return p;
}

object* newobject (elem* a)
{
object* p;
p=memory;
object* q;
q=buildobject(a);
if (p==NULL) memory=q;
else
	{
	while (p->next!=NULL) p=p->next;
	p->next=q;
	}
return q;
}

verb* newverb(elem* a,object* o,int ty=0,int ti=0)
{
verb* p;
p=o->toverb;
verb* q;
q=buildverb(a,ty,ti);
if (p==NULL) (o->toverb)=q;
else 
	{
	while (p->next!=NULL) p=p->next;
	p->next=q;
	}
return q;
}

attrib* newattrib(elem* a,verb* v,int goo=0)
{
attrib* p;
p=v->toattrib;
attrib* q;
q=buildattrib(a,goo);
if (p==NULL) (v->toattrib)=q;
else 
	{
	while (p->next!=NULL) p=p->next;
	p->next=q;
	}
return q;
}



int delattrib(attrib*& p)
{
if (p==NULL) return 0;
if (p->next!=NULL) delattrib(p->next);
delall(p->it);
delete p->why;
delete p->so;
delete p;
return 1;
}


int delverb(verb*& p)
{
if (p==NULL) return 0;
if (p->next!=NULL) delverb(p->next);
delattrib(p->toattrib);
delall(p->it);
delete p;
return 1;
}


int delobject(object*& p)
{
if (p==NULL) return 0;
if (p->next!=NULL) delobject(p->next);
delverb(p->toverb); 
delall(p->it);
delete p;
return 1;
}




int writeattrib(attrib* p)
{
if (p==NULL) return 0;
cout <<"\t" <<"(good:"<<p->good<<") ";
writeelem(p->it);
cout <<" "<<p->number<<" "<<p->why_number<<" ";
if (p->why_number!=0) cout << "(" << p->why[0] <<") ";
cout << p->so_number <<" ";
if (p->so_number!=0) cout << "(" << p->so[0] <<") ";
cout <<endl;
if (p->next!=NULL) cout <<"\t\t\t\t";
writeattrib(p->next);
return 1;
}


int writeverb(verb* p)
{
if (p==NULL) return 0;
cout <<"\t(type:"<<p->type<<" ";
cout <<"time:"<<p->time<<") ";
writeelem(p->it);
writeattrib(p->toattrib);
if (p->next !=NULL) cout <<"\t";
writeverb(p->next);
return 1;
}


int writeobject(object* p)
{
if (p==NULL) return 0;
writeelem(p->it);
writeverb(p->toverb);
writeobject(p->next);
return 1;
}
